#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>
#include <math.h>

int main(int argc, char* argv[ ]) {

   // MPI bookkeeping variables
   int numP;
   int pid;
   MPI_Request sendR, recvR;
   MPI_Status sendS, recvS;

   // MPI Initialization 
   // ADD AN MPI_INIT STATEMENT HERE
   // ADD AN MPI_Comm_size CALL HERE TO GET THE VALUE OF numP.
   // ADD AN MPI_Comm_rank STATEMENT HERE TO GET THE VALUE OF pid

   int log2NumP = (int) log2(numP);
   int rVal; // received value in reduction
   int sVal = pid; // sent value in reduction

   // time the MPI reduction
   double t = MPI_Wtime( );
   // AADD AN MPI REDUCE HERE.  THE VALUE YOU SHOULD REDUCE ON IS sVal, THE REDUCED VALUE SHOULD 
   // BE PUT INTO rVal, AND THE ROOT SHOULD BE 0.
   t = MPI_Wtime( ) - t;
   
   if (pid == 0) {
      printf("MPI reduction time on pid %d is %f\n", pid, t);
      printf("MPI reduction value is %d\n", rVal);
   }

   // time our reduction
   t = MPI_Wtime( );
   for (int level = 1; level < log2NumP+1; level*=2) {
      if (pid%(2*level) == 0) { // a receiver
         // ADD AN MPI_Irecv CALL HERE
      }

      if (pid%(2*level) == level) { // a sender
         // ADD AN MPI_ISecv CALL HERE
      }
         
      if (pid%(2*level) == 0) { // a receiver
         // ADD AN MPI_WAIT TO WAIT ON THE RECV HERE
      }

      if (pid%(2*level) == level) { // a sender
         // ADD AN MPI_WAIT TO WAIT ON THE SENDHERE
      }

      sVal += rVal;
   }
   t = MPI_Wtime( ) - t;
   
   printf("time for my reduction on pid %d is: %f\n", pid, t);
   if (pid == 0) {
      printf("time for my reduction on pid %d is: %f\n", pid, t);
      printf("my reduction value is %d\n", sVal);
   }
}
